(* Applichiamo Programmazione Strutturata allo Sviluppo del QuickSort.
   Vincoli: 
   + Una sequenza c;
   + di valori ordinabili t (generico)
   + Quindi, c e' un valore di tipo Seq(t), sequenze di tipo t.
   + Ordinamento totale op:
   	 perogni x,y: (1) (op x y)or(op y x);  (2) (op x y)and(op y x) iff x=y;
   Algoritmo
   1) Sia cc la sequenza corrente da ordinare;
   2) Sia op ordinamento totale sui valori di tipo t da utilizzare; 
   3) Sia pv di tipo t, un elemento di separazione per cc;
   4) Dividiamo cc in due sottosequenze cLE, cGT separate da a;
   5) Ripetere 1)-5) su ogni sottosequenza, non singoletta, ottenuta da 4);
   6) Terminiamo presentando la sequenza ottenuta
   Osservazioni:
   o1: pv elemento di cc, arbitrariamente scelto e rimosso da cc;
   o2: separazione: 
   			+ se x in cLE allora (op x a)or(x=a)
   			+ se x in cGT allora (op a x)
   			+ cLT seguito da pv, seguito da cGT, e' una permutazione di cc  
   o3: op e` un valore funzione (predicato) trasmesso come parametro.
*)

# use "SeqT.ml";;  (* carica il codice del tipo di dato:'t seq *)
				   (* per sequenze polimorfe in 't             *)

let rec quickSort (cc:'t seq) (op:'t ->'t ->bool) = 
		(* Out: copia ordinata con op degli elementi di cc *)
		(* effect: nessuna modifica                        *)
	if size cc <= 1 then cc
	else let (pv,cv) = pivot cc in	
		 let (cLE,cGT) = dividi cv op pv in
		 concatena (quickSort cLE op)(cons pv (quickSort cGT op))
;;




(* quando importiamo SeqT,ml:
# let cc = Cons(2,Cons(5,Cons(0,Cons(-3,Cons(0,Cons(21,Cons(0,Cons(2,Cons(0-2,Cons(0,Cons(3,Nil)))))))))));;
val cc : int seq =
  Cons (2,
   Cons (5,
    Cons (0,
     Cons (-3,
      Cons (0,
       Cons (21, Cons (0, Cons (2, Cons (-2, Cons (0, Cons (3, Nil)))))))))))val cc : int seq =
# val cc : int seq =
    Cons (2,
     Cons (5,
      Cons (0,
       Cons (-3,
        Cons (0, Cons (0, Cons (2, Cons (-2, Cons (0, Cons (3, Nil)))))))))))
         Cons (21, Cons (0, Cons (2, Cons (-2, Cons (0, Cons (3, Nil)))))))))))cc;;
Error: Syntax error
# cc;;
- : int seq =
Cons (2,
 Cons (5,
  Cons (0,
   Cons (-3,
    Cons (0,
     Cons (21, Cons (0, Cons (2, Cons (-2, Cons (0, Cons (3, Nil)))))))))))
# quickSort cc (<);;
- : int seq =
Cons (-3,
 Cons (-2,
  Cons (0,
   Cons (0,
    Cons (0,
     Cons (0, Cons (2, Cons (2, Cons (3, Cons (5, Cons (21, Nil)))))))))))
# 
*)

(* quando importiamo SeqT1.ml
# #use "QuickSortT.ml";;
type 't seq = 't list
val size : 't seq -> int = <fun>
val pivot : 't seq -> 't = <fun>
val triPartition :
  't seq -> ('t -> 't -> bool) -> 't -> 't seq * 't seq * 't seq = <fun>
val concatena : 't seq -> 't seq -> 't seq = <fun>
val cons : 't -> 't seq -> 't seq = <fun>
val quickSort : 'a seq -> ('a -> 'a -> bool) -> 'a seq = <fun>
# quickSort [2;5;0;-3;0;21;0;2;0-2;0;-3] (<);;
- : int seq = [-3; -3; -2; 0; 0; 0; 0; 2; 2; 5; 21]
*)