(* implementazione del tipo di dato 't seq *)
type 't seq = Nil | Cons of 't * ('t seq);;    (* Tipo di Dato Algebrico *)

(* exceptions *)
exception Err1 of string * string;;

(* operazioni di 't seq richieste in QuickSort *)
let rec size seq = match seq with 
			(* Out: numero di elementi 't contenuti in seq *)
			(* effect: nessuna modifica                    *)
		| Nil -> 0
		| Cons(_,xs) -> 1 + size xs
;;
let pivot seq = match seq with
			(* Out: coppia (ElementoSelezionato,SequenzaRimanente) per seq *)
			(* effect: nessuna modifica                                    *)
		| Nil -> raise (Err1("pivot", "illegal arg: Nil seq"))
		| Cons(x,xs) -> (x,xs)
;;
let rec dividi seq op pv = match seq with
			(* Out: partiziona seq (rispetto a pv, con ordine op) in una *)
			(*         coppia (MinoriUguali,Maggiori) *)
			(* effect: nessuna modifica               *)
		| Nil -> (Nil,Nil)
		| Cons(x,xs) -> 
				let (le,gt) = dividi xs op pv in
				if (op x pv)||(x = pv) then ((Cons(x,le)),gt)
				else (le,Cons(x,gt))
		;;
let rec concatena seq1 seq2 = match seq1 with
			(* Out: concatena seq1 con seq2 *)
			(* effect: nessuna modifica     *)
		| Nil -> seq2
		| Cons(x,xs) -> Cons(x,(concatena xs seq2))
;;
let cons x xs = 
			(* Out: aggiunge x in testa ad xs *)
			(* effect: nessuna modifica       *)
		Cons(x,xs)
;;

