open List;;

(* implementazione del tipo di dato 't seq *)
type 't seq = 't list;; (* sequenze polimorfe implementate con liste *)

(* operazioni di 't seq richieste in QuickSort *)
let (size:'t seq ->int) = 
			(* Out: numero di elementi 't contenuti in seq *)
			(* effect: nessuna modifica                    *)
		fun x -> length x
;;
let (pivot:'t seq -> 't) = 
			(* Out: ElementoSelezionato come pivot *)
			(* effect: nessuna modifica            *)
		fun x -> hd x
;;
let rec (triPartition: 't seq -> ('t -> 't -> bool) -> 't 
						-> ('t seq * 't seq * 't seq)) = 
			(* Out: partiziona seq (rispetto a pv, con ordine op) in una *)
			(*         tripla (Minori,Uguali,Maggiori)                   *)
			(* effect: nessuna modifica                                  *)
        fun seq op pv ->
			match seq with
				|[] -> ([],[],[])
				|x::xs -> let ((lt:'t seq),(eq:'t seq),(gt:'t seq)) 
								= triPartition xs op pv in
			  			  if op x pv then (x::lt,eq,gt)
			              else if op pv x then (lt,eq,x::gt)
			              else (lt,x::eq,gt)
;;
let (concatena: 't seq -> 't seq -> 't seq) = 
			(* Out: concatena seq1 con seq2 *)
			(* effect: nessuna modifica     *)
		fun x y -> x@y
;;
let (cons: 't -> 't seq -> 't seq) = 
			(* Out: aggiunge x in testa ad xs *)
			(* effect: nessuna modifica       *)
		fun x xs -> x::xs
;;

